{-# LANGUAGE DeriveGeneric #-}
{-# LANGUAGE DerivingStrategies #-}
{-# LANGUAGE GeneralizedNewtypeDeriving #-}
{-# LANGUAGE LambdaCase #-}
{-# LANGUAGE OverloadedStrings #-}
{-# LANGUAGE PatternSynonyms #-}
{-# LANGUAGE StrictData #-}
{-# LANGUAGE NoImplicitPrelude #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}

-- Derived from AWS service descriptions, licensed under Apache 2.0.

-- |
-- Module      : Amazonka.Personalize.Types.ObjectiveSensitivity
-- Copyright   : (c) 2013-2023 Brendan Hay
-- License     : Mozilla Public License, v. 2.0.
-- Maintainer  : Brendan Hay
-- Stability   : auto-generated
-- Portability : non-portable (GHC extensions)
module Amazonka.Personalize.Types.ObjectiveSensitivity
  ( ObjectiveSensitivity
      ( ..,
        ObjectiveSensitivity_HIGH,
        ObjectiveSensitivity_LOW,
        ObjectiveSensitivity_MEDIUM,
        ObjectiveSensitivity_OFF
      ),
  )
where

import qualified Amazonka.Core as Core
import qualified Amazonka.Data as Data
import qualified Amazonka.Prelude as Prelude

newtype ObjectiveSensitivity = ObjectiveSensitivity'
  { fromObjectiveSensitivity ::
      Data.Text
  }
  deriving stock
    ( Prelude.Show,
      Prelude.Read,
      Prelude.Eq,
      Prelude.Ord,
      Prelude.Generic
    )
  deriving newtype
    ( Prelude.Hashable,
      Prelude.NFData,
      Data.FromText,
      Data.ToText,
      Data.ToByteString,
      Data.ToLog,
      Data.ToHeader,
      Data.ToQuery,
      Data.FromJSON,
      Data.FromJSONKey,
      Data.ToJSON,
      Data.ToJSONKey,
      Data.FromXML,
      Data.ToXML
    )

pattern ObjectiveSensitivity_HIGH :: ObjectiveSensitivity
pattern ObjectiveSensitivity_HIGH = ObjectiveSensitivity' "HIGH"

pattern ObjectiveSensitivity_LOW :: ObjectiveSensitivity
pattern ObjectiveSensitivity_LOW = ObjectiveSensitivity' "LOW"

pattern ObjectiveSensitivity_MEDIUM :: ObjectiveSensitivity
pattern ObjectiveSensitivity_MEDIUM = ObjectiveSensitivity' "MEDIUM"

pattern ObjectiveSensitivity_OFF :: ObjectiveSensitivity
pattern ObjectiveSensitivity_OFF = ObjectiveSensitivity' "OFF"

{-# COMPLETE
  ObjectiveSensitivity_HIGH,
  ObjectiveSensitivity_LOW,
  ObjectiveSensitivity_MEDIUM,
  ObjectiveSensitivity_OFF,
  ObjectiveSensitivity'
  #-}
